; Variables, constants, and macros GUI BGE v4.0
; ,    GUI BGE v4.0

CS      EQU #E3
SS      EQU #0E

;     x8/x1  --in v 4.0

    MACRO WINCALL tn_
      call WinFunc
      DB tn_
    ENDM

    MACRO wincall tn_
      call WinFunc
      DB tn_
    ENDM

    MACRO WinCall tn_
      call WinFunc
      DB tn_
    ENDM


; , , /,  (buffer, addr, sector/track, page)
; B = -  (number of sectors)

        MACRO EXLOAD p1,p2,p3,p4
        LD A,p4
        LD HL,p1
        LD DE,p2
        LD IX,(p3)
        LD C,#05
    ;    LD A,p4     ;        a   /DA
        EX AF,AF'
        LD A,SL_BANK
        CALL GUI
        ENDM

; , ,   ,  (buffer, addr, byte length, page)
; B = -  (number of sectors)
;   (save file)

        MACRO EXSAVEF p1,p2,p3,p4
        LD A,p4
        LD HL,p1
        LD DE,p2
        LD IX,p3
        LD C,11
     ;   LD A,p4   ;        a   /DA
        EX AF,AF'
        LD A,SL_BANK
        CALL GUI
        ENDM

        MACRO RestSpp
        DI
        LD SP,(Spp)
        EI
        ENDM

        MACRO HLFHL
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        ENDM

        MACRO DEFHL ;macro for LD DE,(HL)
        LD E,(HL)
        INC HL
        LD D,(HL)
        ENDM

        MACRO DEFHL1 ;LD DE,(HL):INC HL
        LD E,(HL)
        INC HL
        LD D,(HL)
        INC HL
        ENDM

        MACRO Amul8
        ADD A,A
        ADD A,A
        ADD A,A
        ENDM

        MACRO CPHL0
        LD A,H
        OR L
        ENDM

   ;     MACRO DHL_     ; ,     INC_Y  ; /DA
   ;     ...

        MACRO HL0
        AND A
        SBC HL,HL
        ENDM

        MACRO ldbc num,num1   ; ld bc,#{num num1}   ; /DA
         ld bc,num*256+num1
        ENDM
        MACRO LDBC num,num1
         ldbc num num1
        ENDM

        MACRO RCOD
          ld a,h
          ld h,l
          ld l,a
        ENDM

; Constants of GUI

RadioOn  EQU 1              ; - . (radio-button on)
RadioOff EQU 2              ; - . (radio-button off)
SwchOn   EQU 3              ;  . (flag on)
SwchOff  EQU 4              ;  . (flag off)
Nil      EQU 0              ;   () (no value)
SortCAT  EQU #FFFE-128      ;          v3.12
NEWCAT   EQU #FFFE-#0800    ;    (sorted file list)      
CAT      EQU NEWCAT-#0900   ;   (full directory)

; Main variable of GUI

GuiVars           ;             /DA

Numb    DEFB 0    ;    (number of selected highlighting)
But     DEFB 0    ;    (number of selected button)
DIRECT  DEFB 0
MDIRECT DEFB 0
ARW_X   DEFB 127  ;. (starting cordinates...)
ARW_Y   DEFB 95   ;  . . (...of the cursor)
ARW_XC  DEFB 0    ;    (in characters here)
ARW_YC  DEFB 0    ;
ARWXMN  DEFB 0    ;x min
ARWXMX  DEFB 255  ;x max
ARWYMN  DEFB 0    ;y min
ARWYMX  DEFB 191  ;y max
XPLACE  DEFW 22528    ; #5800
ARW_ADR DEFW ARWSPR
STEP    DEFB 6
LEVEL   DEFB 10
SPEED   DEFB 1
ARWSPR  DB 63,0,15,64,131,48,129,60
        DB 193,24,193,20,224,2,252,0
        DB 255,0,255,0
KJOY    DB 0 ; KEMPSTON JOY

; Main variable of ListBox

SpAdr    DW 0    ;    (start addr of the list)
SpAdrT   DW 0    ;     (start addr of visible list)
SpLen    DW 0    ;     (length of full title of the list)
SpLenW   DW 0    ;     (length of title of visual list)
SpLenD   DW 0    ;     .  (length of title with extra text)
SpDop    DW 0    ;     (addr of procedure "add to list")
SpBar    DB 0    ;   (length of highlighting)
SpFiler  DB 0    ;  ? (is this a file selector?)
SpXY     DW 0    ; X,Y    (X,Y of the list in the window)
SelSp    DB 0    ;     (item number in the list)
SpDop2   DW 0    ;      (add text after the list)
TAB_SORT DW 0    ;   (sorting table)


; Main Constants of TRDOS

LAST_KEY   EQU 23560
FILE_PARAM EQU #5CDD
FILE_NAME  EQU #5CDD
FILE_TYPE  EQU #5CE5
START_ADR  EQU #5CE6
BYTES_LEN  EQU #5CE8
SEC_LEN    EQU #5CEA
START_SEC  EQU #5CEB
START_TRK  EQU #5CEC
TEK_SEC    EQU #5CF4
TEK_TRK    EQU #5CF5

Sys_PAGE   EQU #5B5C   ;   #7FFD    

; Main variable of FDOS

Spp       DW 0         ;  ,     (stack address for error handling)
;MODE      DB #00       ;    (turbo driver flag) oldest version
MODE      DB %0000     ;   (turbo drivers flags)      new format for v3.12 ;/DA
                       ; bits : 0 - A , 1 - B , 2 - C , 3 - D ( 1 - turbo driver / 0 - tr-dos #3D13 )
RECAT     DB 0         ;      (re-read directory after save)
 ; RAMDR     DB 2  ;   #3D13 (drive with #3D13) ; delete function in v3.12 ;/DA
MWHEEL    DB 0      ;    (kempston) at v3.12 exchange deleted 'RAMDR' /DA
                    ;    
OVERF     DB 0

;ResAdr    DW 0 ;  { v 3.12    (resident addr)},   Sys_Disk  Curr_Disk
Sys_Disk   DB 0  ;    BGE
Curr_Disk  DB 0  ;     

END_DISK  DW 0         ;  /  (last track/sector of the disk)

; Disk constants

All_File EQU 228
Free_Sec EQU 229
End_Disk EQU 225

; ReadKey variable

KEYS
KEY1    DB 0
KEY2    DB 0

; Mouse variable
FIRE    DB 0        ; 0 -  ; !=0 - fire
CANCEL  DB 0        ; 0 -  ; !=0 - cancel

SPACE   DEFS 50;51
        DB 0        ;  51   
; CROSSON db 0 ;#ff ;    /DA

BRK     DB 0          ; %00001 -  (fire)
                      ; %00010 -  (cancel) (3-   / )
                      ; %00100 -  (mouse)
                      ; %00000 - halt
                      ; %01000 -     (for v3.12)
                      ; %10000 - Fire2 (for v 4.0)

FREE_SEC        DW 0  ;     (number of free sectors on the disk)
ALL_FILE        DW 0  ;     (number of files on the disk)

;      LOAD_CAT, ,
;   ,    GUI (,
;  ,     ...)
;(the following variables are set after calling LOAD_CAT, it is called
;by GUI disk functions (file selector, save file, load file with reading the header...))
; END_DISK       /  (last track/sector of the disk)
; FREE_SEC          (number of free sectors on the disk)
; ALL_FILE          (number of files on the disk)

MICE            DB 0  ;#ff      ;  (mouse flag)
MB              DB 0      ;  (reverse buttons flag)

; ------------- BGE 3.09 added -------------

ARW_SDISP       DB 0,0   ;        x,y   
ARW_XDISP       DB 0     ;        X
ARW_YDISP       DB 0     ;        Y

    ;PixelMSK   DB 0  ;   : 0-15  , 16-32 -   / v3.09.04   Texture.fsolid
Texture.fsolid  DB 0     ;     ; #FF -solid , 0 - textured
Magnify_x8      DB #FF   ;0 ; /DA   0 -  x4 , !=0 - x8
Sieve           DB 0     ; #FF  -   0 - , #FF -  (  ) /DA

; ------------ BGE 3.11 added -------------

DarwX           DW 0  ; word       X > 256                        / DA
DarwXM          DB 32 ; lo byte       X   / DA
OVR_proc        DB 0  ;     (     )

; ------------ BGE 3.12 added -------------
MiniLoupePG     DB ScrPage   ;      miniloupe

; ------------ BGE 4.0 added -------------
MBut2toFire2    DB 0 ;  2-    Fire-2
Fire2           DB 0 ;  0 -  ; !=0 - fire2
;-----------------------------------------------------------------------------------


;***********************************************************************************

;  Numbers of system buttons sprites of BGE \     BGE

; ------------- BGE 3.09 added ---------------

  ; If add bit 7 (+128) then used last half sprite addr. \    7 (+128),      .

DISKS       EQU 1
PGN1S       EQU 2
PGN2S       EQU 2+128
CHRS        EQU 3
WIN8S       EQU 4
WIN1S       EQU 5
RGBS        EQU 6
MGFS        EQU 7
CNKS        EQU 8
NALS        EQU 9
EK2S        EQU 10
FILLS       EQU 11
PRIMS       EQU 12
BOXS        EQU 13
OTHERS      EQU 14
UNDOS       EQU 15
EXITS       EQU 16
OFFS        EQU 17
ONS         EQU 18
DTRS        EQU 19   ;   
PLOTS       EQU 20
LINES       EQU 21
LINES2      EQU 22
TRS         EQU 23
SQS         EQU 24
CIRCS       EQU 25
ELPS        EQU 26
RAYS        EQU 27
XORS        EQU 28
ANDS        EQU 29
ORS         EQU 30
NOPS        EQU 31
ERASES      EQU 32
SETKAS      EQU 33
RAMKAS      EQU 34
FILLS2      EQU 35
AMASKS      EQU 36
NORGBS      EQU 37
WASHS1      EQU 38
BRUSHS      EQU 39
ZOOM8       EQU 40
ZOOM4       EQU 41
LASTONS     EQU 42
FILLSQS     EQU 43
BOLDDOTS    EQU 44
DTPMASKS    EQU 45
SPRAYS      EQU 46
SPRITESS    EQU 47

; -------------- BGE 3.11 added ---------------
DITHCANS    EQU 48

; -------------- BGE 3.12 added ---------------


LOOKS       EQU 49
LEFTS       EQU 50
RIGHTS      EQU 51
DTRMSS      EQU 52    ;  
DTRCSS      EQU 53    ;  

bgeSPRTnum  EQU 53    ;   2x2  

SPACES      EQU 80   ; sprite size 1x2 for empty places (     1x2)

;   BGE  2x1

DSK_AS      EQU 80+128    ; 
DSK_BS      EQU 81
DSK_CS      EQU 81+128
DSK_DS      EQU 82
DSK_ES      EQU 82+128

DIRECT_LS   EQU 83    ; 
DIRECT_RS   EQU 83+128
DIRECT_US   EQU 84
DIRECT_DS   EQU 84+128



    display "End GuiVar:", $
